#include "stdafx.h"
#include "IconDlgTest.h"
#include "IconDlgTestDlg.h"
#include "IconDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#pragma warning(suppress: 26455)
CIconDlgTestDlg::CIconDlgTestDlg(_In_opt_ CWnd* pParent) : CDialog{CIconDlgTestDlg::IDD, pParent},
                                                           m_hIcon{AfxGetApp()->LoadIcon(IDR_MAINFRAME)},
                                                           m_nIconIndex{-1},
                                                           m_bRetrievedIcon{FALSE}
{
}

void CIconDlgTestDlg::DoDataExchange(CDataExchange* pDX)
{
  __super::DoDataExchange(pDX);
  DDX_Control(pDX, IDC_SELECTED_ICON, m_ctrlSelectedIcon);
}

#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CIconDlgTestDlg, CDialog) //NOLINT(clang-diagnostic-unused-local-typedef, modernize-avoid-c-arrays)
  ON_BN_CLICKED(IDC_SHOW, &CIconDlgTestDlg::OnShow)
END_MESSAGE_MAP()

BOOL CIconDlgTestDlg::OnInitDialog()
{
  //Let the base class do its thing
  __super::OnInitDialog();

  SetIcon(m_hIcon, TRUE);
  SetIcon(m_hIcon, FALSE);
  return TRUE;
}

void CIconDlgTestDlg::OnShow()
{
  CIconDialog dlg{this};
  if (m_bRetrievedIcon)
    dlg.SetIcon(m_sFilename, m_nIconIndex);
  if (dlg.DoModal())
  {
    dlg.GetIcon(m_sFilename, m_nIconIndex);
    HICON hIcon{ExtractIcon(AfxGetInstanceHandle(), m_sFilename, m_nIconIndex)};
    HICON hOldIcon{m_ctrlSelectedIcon.SetIcon(hIcon)};
    SetIcon(hIcon, TRUE);
    SetIcon(hIcon, FALSE);
    if (hOldIcon != nullptr)
      DestroyIcon(hOldIcon);
    m_bRetrievedIcon = TRUE;
  }
}
